//------------------------------------------------------------------------------
// Paul Dibden 
// BA(HONS)Computer Visualisation & Animation 2004
// Innovations - 2D Pen & Ink lines in the V direction shader
//------------------------------------------------------------------------------

surface peninkvdirection (    float dpscale = 0.1;
 			    		float frequency = 40;
		 	    		float duty = 0.50;
		          		float normaldo = 1.0;
		          		float Ka = 0.2;
		          		float Kd = 0.8;
		 	    		color stripecolor = 0;
				 )

{
    color diffuzeC;
    float diffuze;
 
    point Pscreen = transform("screen", P);
    vector dp = dpscale * vtransform("screen", dPdv);
    setzcomp(dp, 0.0);

//for shader to work relative to the canvas in screen space,
//transform derivative and hold it in z.

    float lendp = mix (length(dp), length(dPdv), normaldo);

//length(dPdu)to test how stretched the surface is in the
//direction normal to the stripes.

/*---------------------uniform line density----------------------*/

    float logdp = log(frequency * lendp, 2.0);
//log base 2 of (frequency*lendp)

    float ilogdp = floor(logdp);

    float stripes = pow(2,ilogdp);			
//restore multiplier

/*---------------------simple stripe function--------------------*/

    float sawtooth = mod(v * stripes, 1);	
//specifies a sawtooth wave along the v-direction

    float triangle = abs(2.0 * sawtooth - 1.0);
//converted into a triangle wave

/*---------------------lighting----------------------------------*/

  diffuzeC=Ka*ambient()+Kd*diffuse(faceforward(normalize(N),I));
  diffuze=(comp(diffuzeC,0)+comp(diffuzeC,1)+comp(diffuzeC,2))/3.0;
    
/*---------------------------------------------------------------*/

    float square = filterstep(duty * diffuze, triangle);
//convert to a square wave,with a duty cycle.

//when triangle's wave value rises over the duty value,
//the step fucntion triggers.
//this function provides the uniform striping when applied
//to a simple patch.

    color CC = mix(Cs, stripecolor, square);
  
    Oi = Os;
    Ci = Os * CC;
}
